/***************************************************************************/
/*                                                                         */
/*                        M Y G A M E H E L P E R                          */
/*                                                                         */
/***************************************************************************/




#include "MyGameHelper.h"
// #include "GameTypeHelper.h"

#include "../../MyFrameAl5/globalIncs.h"
#include "../../MyFrameAl5/Data/MultiString.h"
#include "../../MyFrameAl5/FrameGlobalVars.h"

#include "../../MyFrameAl5/Draw/MyText.h"
#include "../../MyFrameAl5/Draw/DrawPrim.h"
#include "../../MyFrameAl5/Math/CalcHelper.h"
#include "../../MyFrameAl5/Math/Prime.h"
#include "../../MyFrameAl5/Stat/ListStatCommon.h"
#include "../../MyFrameAl5/Stat/ListStat.h"
#include "../../MyFrameAl5/Prj/Prj.h"
#include "../../MyFrameAl5/Math/MyRand.h"
#include "GlobalDefs.h"
#include "layout.h"
#include "MyLivingObject.h"
#include "PlayerEntity.h"
#include "myobj.h"


unsigned short _nCursorRotTarget65536 = 0;
unsigned short _nCursorRotCurrent65536 = 0;
unsigned char _nCursorLastPressFire = 0;

short _nCursorRotVelocity;

CellInfo_t* _nCellLitInfos; // [LITCELLS_MAX_ITEMS]; 
unsigned char _nCellLit_NextAdd = 64;

unsigned long _nNbAsteroidsSpawned;
unsigned char _nNextAsteroidCurrentTime;
unsigned char _nNextAsteroidMaxTime;
char _nNbMissilesLeft;

float NORMALIZED_POSX_MIN;
float NORMALIZED_POSX_MAX;

float ORIGINAL_POSX_MAX;
float ORIGINAL_POSX_MIN;

unsigned long _nTotalExeTime = 0;
unsigned short _nDayTime;
float _fCameraOffsetCurrentX = 0;
float _fCameraOffsetTargetX = 320;
float _fCameraOffsetOldX = 320;
unsigned char _nCameraAnimCurrentTime = 0;
unsigned char _nCameraAnimMaxTime = 30;
float _fGroundLimitYCurrent;
float _fGroundLimitYTarget;
float _fGroundLimitDisplayedLives;
float _fGroundLimitLives;
bool _bDead;
bool _bInit = false;

unsigned char _nLastCollideExplosion;
unsigned long _nScorePlayer;


CListLivingObject* _pListAsteroids = NULL;
CListLivingObject* _pListMyPlayerMissiles = NULL;
CListLivingObject* _pListMyPlayerExplosions = NULL;
CListLivingObject* _pListCities = NULL;


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


/*-------------------------------------------------------------------------*/
/*---------------------------- CMy Game Helper ----------------------------*/
/*-------------------------------------------------------------------------*/
CMyGameHelper::CMyGameHelper(int nDispFlags)
			:CGameHelper(nDispFlags, -1/*default*/, 16)
{
	
}

/*-------------------------------------------------------------------------*/
/*---------------------------- ~ CMy Game Helper --------------------------*/
/*-------------------------------------------------------------------------*/
CMyGameHelper::~CMyGameHelper()
{
	// Should use CJoinEngine instead // DeleteMenuJoin();
}


////////////////////////////////////////////////////////////////////////////
//
//         H E L P E R   F U N C T I O N S
//
////////////////////////////////////////////////////////////////////////////


/*-------------------------------------------------------------------------*/
/*---------------------------- Do Begin Game Ex ---------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::DoBeginGame_Ex()
{
	bool bIsRealGame = !IsDemo();

	_pListPlayers->RemoveAll();
	_pListEnemies->RemoveAll();
	_pListBulletWaves->RemoveAll();
	_pListMissilesCpu->RemoveAll();
	_pListMissilesPlayer->RemoveAll();


	/*--- INITS -----------------------------------------------------------*/
	
	_nLastCollideExplosion = 255;
	_nNbAsteroidsSpawned = 0;
	_nNextAsteroidCurrentTime = 8;
	_nNextAsteroidMaxTime = ASTEROID_IDLE_MAXTIME;
	_nScorePlayer = 0;

	_fGroundLimitLives = PLAYER_NB_LIVES_BEGIN;
	_bDead = false;

	_fGroundLimitYTarget = CITY_YMIN - CITY_HMAX - 16;

	_nNbMissilesLeft = 6;
	_pListMyPlayerExplosions->RemoveAll();
	_pListMyPlayerMissiles->RemoveAll();
	_pListAsteroids->RemoveAll();


	CPlayerEntity* pPlayer = new CPlayerEntity();
	_pListPlayers->Add(pPlayer);

	pPlayer->InitPlayerProps(0, pPlayer);
		

	return 0;
}

/*-------------------------------------------------------------------------*/
/*-------------------- Is Player Status Update Allowed --------------------*/
/*-------------------------------------------------------------------------*/
bool CMyGameHelper::IsPlayerStatusUpdateAllowed()
{
	// TODO
	return true;
}

/*-------------------------------------------------------------------------*/
/*------------------------- Is Player Fire Allowed ------------------------*/
/*-------------------------------------------------------------------------*/
bool CMyGameHelper::IsPlayerFireAllowed()
{
	bool bRet = (IsPlayerTimeCounted() || IsStageCleared());
	return bRet;
}

/*-------------------------------------------------------------------------*/
/*---------------------------- Is Stage Cleared ---------------------------*/
/*-------------------------------------------------------------------------*/
bool CMyGameHelper::IsStageCleared()
{
	return (GetCurrentType() == GAMESCTNTYPE_STGCLEAR);
}

/*-------------------------------------------------------------------------*/
/*------------------------- Is Player Time Counted ------------------------*/
/*-------------------------------------------------------------------------*/
bool CMyGameHelper::IsPlayerTimeCounted()
{
	return (GetCurrentType() == GAMESCTNTYPE_PLAY);
}

/*-------------------------------------------------------------------------*/
/*------------------------ Is Metrics Time Counted ------------------------*/
/*-------------------------------------------------------------------------*/
bool CMyGameHelper::IsMetricsTimeCounted()
{
	return (GetCurrentSection() == SCTN_GAMEPLAY);
}

/*-------------------------------------------------------------------------*/
/*-------------------------- Get Game Type Generic ------------------------*/
/*-------------------------------------------------------------------------*/
char CMyGameHelper::GetGameTypeForPlayer(char nPlayerNum)
{
	// no need to override 
	return CGameHelper::GetGameTypeForPlayer(nPlayerNum);
}



////////////////////////////////////////////////////////////////////////////
//
//         V I R T U A L   F U N C T I O N S
//
////////////////////////////////////////////////////////////////////////////

/*-------------------------------------------------------------------------*/
/*-------------------------------- Stage Clear ----------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::V_DoStageClear()
{
	bool bPerfect = false;
	return 0;
}

/*-------------------------------------------------------------------------*/
/*---------------------------- On Section Change --------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::OnSectionChange()
{
	int nCurrentSection = GetCurrentSection();
	if (GetPreviousSection() != nCurrentSection)
	{		
		switch (nCurrentSection)
		{
		case SCTN_TITLE:
			if (!_bInit)
			{
				_bInit = true;
				_pSoundEngine->PlayMusic(SNDGRPNUM_BGM_GAME, -1);
			}
			break;

		case SCTN_GAMEPLAY: 
			break;

		case SCTN_GAMEOVER: 
			break;
		}
	}
}

/*-------------------------------------------------------------------------*/
/*--------------------------- Manage Combo Break --------------------------*/
/*-------------------------------------------------------------------------*/
void ManageComboBreak()
{
}

/*-------------------------------------------------------------------------*/
/*------------------------ Do Shock Wave On Cities ------------------------*/
/*-------------------------------------------------------------------------*/
void DoShockWave_OnCities(CMyLivingObject* pAsteroid)
{
	for (int nCityNum=_pListCities->GetLength()-1; nCityNum > 0; nCityNum--)
	{
		CCityRect* pCity = (CCityRect*)_pListCities->GetItem(nCityNum);
		pCity->DoAsteroidImpact(pAsteroid);
	}
}

/*-------------------------------------------------------------------------*/
/*---------------------- Check Asteroids Reach Ground ---------------------*/
/*-------------------------------------------------------------------------*/
void CheckAsteroids_ReachGround()
{
	float fFakeH = 200.0f;

	CAsteroid* pCollidingAsteroid = (CAsteroid*)_pListAsteroids->GetCollidedItem_Pos(
		  0.5f*BITMAP_W
		, _fGroundLimitYTarget+0.5f*fFakeH
		, 1.1f*(NORMALIZED_POSX_MAX-NORMALIZED_POSX_MIN)
		, fFakeH);

	if (pCollidingAsteroid != NULL)
	{
		// Deglingue le dcor
		DoShockWave_OnCities(pCollidingAsteroid);

		// Friendly: Fake Explosion Bonus
		CMyExplosion* pExpl = new CMyExplosion();
		pExpl->Init(
			  pCollidingAsteroid->m_fOriginalX
			, pCollidingAsteroid->m_fY, 0, -1, true);
		_pListMyPlayerExplosions->Add(pExpl);
		pExpl->m_fW = EXPLRECT_COLL_W;
		pExpl->m_fH = EXPLRECT_COLL_H;

		// Tue l'astroide sinon c'est injouable
		pCollidingAsteroid->Kill();
		ASSERT(pCollidingAsteroid->IsDisposable());

		// Un peu de stuff en cadeau
		_nNbMissilesLeft++;

		// Cosmetics
		_pQuake->SetQuake(QUAKE_MEDIUMTIME);

		// Test GameOver
		_fGroundLimitYTarget += 16.0f;
		_fGroundLimitLives -= 1.0f;

		if (_fGroundLimitLives <= 0.0f)
		{
			_pGameHelper->GoToSectionByType(GAMESCTNTYPE_GAMEOVER);

			// Spawn EVEN MORE Explosions
			float fOriginalCenterX = pCollidingAsteroid->m_fOriginalX;
			float fExplosionScopeDx = 0.25f*BITMAP_W;
			_bDead = true;
			_pQuake->SetQuake(QUAKE_LONGTIME);

			for (int nMoreExpls=10; nMoreExpls > 0; nMoreExpls--)
			{			
				CMyExplosion* pExpl = new CMyExplosion();
				pExpl->Init(
					  fOriginalCenterX + GetRandFloat_MinMax(-fExplosionScopeDx, fExplosionScopeDx)
					, pCollidingAsteroid->m_fY + (CITY_YMAX-CITY_YMIN)*GetRandFloat_MinMax(-0.1f, 1.0f)
					, 0, 8*nMoreExpls, false);
				_pListMyPlayerExplosions->Add(pExpl);
			}
		}
	}

	// Smooth Anim
	if (_fGroundLimitYTarget < _fGroundLimitYCurrent)
	{
		_fGroundLimitYCurrent -= 2.0f;
		_fGroundLimitYCurrent = MAX(_fGroundLimitYTarget, _fGroundLimitYCurrent);
	}
	else if (_fGroundLimitYTarget > _fGroundLimitDisplayedLives)
	{
		_fGroundLimitYCurrent += 0.5f;
		_fGroundLimitYCurrent = MIN(_fGroundLimitYTarget, _fGroundLimitYCurrent);
	}
}

/*-------------------------------------------------------------------------*/
/*---------------------------------- Game Play ----------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::V_DoGamePlay(bool bIsRealGame)
/*
	must return any of these:
	GAMESCTNTYPE_NONE
	GAMESCTNTYPE_PLAY
	GAMESCTNTYPE_STGCLEAR
	GAMESCTNTYPE_GAMEOVER
 */
{
	int nCounter = GetStageElapsedTime();
	if (!bIsRealGame)
	{
		nCounter = GetTotalExecutionTime();
	}

	MoveMouseCursor();
	MoveLitCells();

	_nDayTime++;


	if (_nLastCollideExplosion < 255)
		_nLastCollideExplosion++;	

	if (bIsRealGame && _nTotalExeTime%(8*BEAT_PERIOD) == 0)
	{
		_nNbMissilesLeft++;
	}

	_nNextAsteroidCurrentTime--;
	if (_nNextAsteroidCurrentTime == 0)
	{
		CAsteroid* pAstItem = new CAsteroid();
		pAstItem->Init();
		_pListAsteroids->Add(pAstItem);

		
	}

	



	/////////////////////////////////////////////////////////////////////////
	//
	//  GAME LOGIC

	//if (CanMoveGeneralEntities())
	//{
	//

	//	

	//	_pListEnemies->Move();

	//	_pListBulletWaves->DoLogic();
	//	
	//	_pListMissilesPlayer->Move();
	//	_pListMissilesCpu->Move();
	//	_pListBonuses->Move();

	//
	//	// Collisions Missile-Entity
	//	_pListMissilesPlayer->ManageCollisions_ListLivingObject(_pListEnemies);
	//	//_pListMissilesCpu->ManageCollisions_ListLivingObject(_pListPlayers);
	//	
	//	// Collisions Entity-Entity
	//	//_pListPlayers->ManageCollisions_ListLivingObject(_pListEnemies);

	//	// Collisions Bonus-Entity
	//	//_pListBonuses->ManageCollisions_ListLivingObject(_pListPlayers);		
	//	//_pListBonuses->ManageExplosions_Explode();

	//	// Manage Entities LifeBar 
	//	_pListMissilesPlayer->ManageExplosions_Explode();
	//	_pListMissilesCpu->ManageExplosions_Explode();
	//	_pListEnemies->ManageExplosions_Explode();
	//	_pListPlayers->ManageExplosions_Explode();
	//	ManageComboBreak();

	//	// Info
	//	//_pListInfoTexts->Move();
	//}


	_pListPlayers->Move();

	_pListMyPlayerMissiles->Move();
	_pListMyPlayerExplosions->Move();
	
	_pListMyPlayerExplosions->ManageCollisions_ListLivingObject(_pListAsteroids, true);
	
	_pListAsteroids->Move();
	_pListCities->Move();


	// Move "LifeBar" gradually

	if (_fGroundLimitLives < _fGroundLimitDisplayedLives)
	{
		_fGroundLimitDisplayedLives -= 0.015f;
		_fGroundLimitDisplayedLives = MAX(_fGroundLimitLives, _fGroundLimitDisplayedLives);
	}
	else if (_fGroundLimitLives > _fGroundLimitDisplayedLives)
	{
		_fGroundLimitDisplayedLives += 0.02f;
		_fGroundLimitDisplayedLives = MIN(_fGroundLimitLives, _fGroundLimitDisplayedLives);
	}

	// Explosions
	//_pListExplosionPartsUnder->Move();
	//_pListExplosionPartsOver->Move();
	//_pListParticles->Move();

	//_pTextScroller->Move();
	//_pStarField->Move();
	


	/////////////////////////////////////////////////////////////////////////
	//
	//  MOVE STAGE STATUS

	int nGamePlayState = GAMESCTNTYPE_NONE;


	switch (GetCurrentType())
	{
	case GAMESCTNTYPE_PLAY:
		nGamePlayState = GAMESCTNTYPE_PLAY;	
		CheckAsteroids_ReachGround();
		break;

	case GAMESCTNTYPE_DEAD:
		if (CPlayerEntity::IsPressingFire())
		{
			GoToSectionByType(GAMESCTNTYPE_PLAY);
			nGamePlayState = GAMESCTNTYPE_PLAY;
		}
		break;

	case GAMESCTNTYPE_GAMEOVER:
		if (CPlayerEntity::IsPressingFire())
		{
			GoToNextSection();
		}
		break;
	}

	switch (GetCurrentType())
	{
	case GAMESCTNTYPE_INIT:
		break;

	default:
		_nTotalExeTime++;
		break;
	}

	
	
	return nGamePlayState;
}

/*-------------------------------------------------------------------------*/
/*-----------------------------  Do Begin Game ----------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::V_DoBeginGame( bool bRealGame )
{
	return DoBeginGame_Ex(
		);
}

/*-------------------------------------------------------------------------*/
/*----------------------------  Do Begin Stage ----------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::V_DoBeginStage()
{
	return 0;
}

/*-------------------------------------------------------------------------*/
/*------------------------------  Do End Stage ----------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::V_DoEndStage()
{
	/* virtual */	
	return 0;
}

/*-------------------------------------------------------------------------*/
/*---------------------------------- End Game -----------------------------*/
/*-------------------------------------------------------------------------*/
int CMyGameHelper::V_DoEndGame(bool bAborted)
{
	/* virtual */
	return 0;
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Save Game Stats --------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::V_DoSaveGameStats()
{
	/* virtual */	
}
	

/*-------------------------------------------------------------------------*/
/*---------------------------------- Draw ---------------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::Draw()
{
	//if (GetCurrentType() != GAMESCTNTYPE_INIT)
	//{
	//	_pStarField->Draw();
	//}

	V_DrawAnySection();

	if (HasCurrentSectionFlag(SCTNDISPFLG_DISPGAMEPLAY))
	{
		V_DrawGamePlay();
	}
	else if (GetCurrentType() != GAMESCTNTYPE_INIT)
	{
		_pJoinEngine->Draw();
	}

	V_DrawTextsOnScreen();
	_pMenuEngine->Draw();

	_pListExplosionPartsOver->Draw();	
	_pListParticles->Draw();
	//_pTextScroller->Draw();

	// Debug text	
	if (DEBUG_DISPLAY_FLAGS != 0x00)
	{
		DrawInfo(0.7f*BITMAP_W, 0);
	}

	//if (GetCurrentType() == GAMESCTNTYPE_INIT
	//	&& _pListFontClip->GetLength() > 0)
	//{
	//	_pListJoypadConfig->DrawConnectedDevices(_pFontNormal, 60, 240);
	//}
}

/*-------------------------------------------------------------------------*/
/*---------------------------- On Section Loop ----------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::OnSectionLoop()
{
}

/*-------------------------------------------------------------------------*/
/*--------------------------- VCheat Go To Clear --------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::V_Cheat_GoToClear()
{
	// TODO //_pAlienGroup->KillAllInvaders();
	
}

/*-------------------------------------------------------------------------*/
/*-------------------------------- Draw Page ------------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::V_DrawGamePlay()
{
	if (DEBUG_DISPLAY_FLAGS & DISPFLG_DBG_GAMEINFO)
	{	
		//mytextprintf4ub(0, BITMAP_H-8,  0,255,255,255, "PL=%d PT=%2d T=%2d", 
		//	_pListPlayers->GetLength(),
		//	_pListParticles->GetLength(),
		//	_nDayCycleCurrentTime/FPS_EXPECTED
		//	);
	}
}

/*-------------------------------------------------------------------------*/
/*---------------------------- VDraw Any Section --------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::V_DrawAnySection()
{
	float fx=0, fy=0;
	int tExe = GetTotalExecutionTime();

	

	/*--- Background ------------------------------------------------------*/

	DrawColoredBackground();
	_pListCities->Draw();
	DrawWavesInBackground();


	// Stuff

	//_pListExplosionPartsUnder->Draw();

	//_pListInfoTexts->Draw();
	//
	//_pListMissilesPlayer->DrawUnder();
	//_pListMissilesCpu->DrawUnder();

	//_pListBonuses->Draw();
	//_pListMissilesPlayer->Draw();	
	//_pListMissilesCpu->Draw();

	//_pListMissilesPlayer->DrawOnTop();	
	//_pListMissilesCpu->DrawOnTop();

	

	

	/*--- real enemies ----------------------------------------------------*/
	//_pListEnemies->Draw();	
	//_pListEnemies->DrawOnTop();

	_pListAsteroids->Draw();


	/*--- player stuff ----------------------------------------------------*/

	_pListMyPlayerExplosions->Draw();
	_pListMyPlayerMissiles->Draw();


	/*--- Ground Shield ---------------------------------------------------*/

	switch (GetCurrentSection())
	{	
	case SCTN_GAMEPLAY:	
		{
			float fx = 0.5f*GROUND_SHIELD_SPR_W;

			for (;; fx += GROUND_SHIELD_SPR_W)
			{
				_pListMovieClips->Draw_W_H_ClipNum(
					_pListMovieClips->GetItemNumByExternalId(MOVIEID_GROUND_SHIELD0)
					, fx, _fGroundLimitYCurrent
					, GROUND_SHIELD_SPR_W, GROUND_SHIELD_SPR_H
					, 0.0f
					, _nTotalExeTime + (fx)/120 
				);

				if (fx >= BITMAP_W + 0.5f*GROUND_SHIELD_SPR_W)
					break;
			}
		}
		break;
	}


	/*--- litcell ---------------------------------------------------------*/

	DrawLitCells();


	/*--- Playable items --------------------------------------------------*/
	
	_pListPlayers->DrawUnder();
	_pListPlayers->Draw();
	_pListPlayers->DrawOnTop();
	

	switch (GetCurrentSection())
	{	
	case SCTN_TITLE:	
		DrawDemoHUD();	
		break;
	}

	DrawMouseCursor();

	//if (_nTotalExeTime%BEAT_PERIOD < 8)
	//{
	//	float fw = ((_nTotalExeTime/BEAT_PERIOD)%4 == 0)? 128 : 64;
	//	DrawMonoQuad4f(320, 240, fw, fw, 0,1,1, 1);
	//}

}

/*-------------------------------------------------------------------------*/
/*-------------------------- VDraw Texts On Screen ------------------------*/
/*-------------------------------------------------------------------------*/
void CMyGameHelper::V_DrawTextsOnScreen()
{
	//char szTemp[64];

	glLoadIdentity();

	//float x1 = 80;
	//float y1 = 200;
	//float fy;

	//float _Y1 = 0.75f*BITMAP_H;

	bool bDispStage = false;
	bool bDispCleared = false;
	int t = GetCurrentSectionElapsedTime();

	

	switch (GetCurrentSection())
	{	
	case SCTN_INITSCREEN:		
		break;

	case SCTN_TITLE:
		DrawTitle();
		DrawCurrentSectionDebug("T");
		break;

	case SCTN_GAMEOVER:
		{			
			DrawCurrentSectionDebug("G");
		}
		break;

	//case SCTN_GAMERESULTS1:
	//	// stats of current game
	//	// DONE in CPlayer::DrawResults()
	//	break;

	case SCTN_JOINMENU1	:
		break;

	case SCTN_GAMEPLAY:	
		if (_pListPlayers->GetLength() > 0)
		{
			CPlayerEntity* pMan = (CPlayerEntity*)_pListPlayers->GetItem(0);
			pMan->DrawHUD();
		}

		break;
	}


}
