// MyGameHelper.h: interface for the CMyGameHelper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYGAMEHELPER_H__8E57A6B0_D577_4FC9_91D1_650A62EE7268__INCLUDED_)
#define AFX_MYGAMEHELPER_H__8E57A6B0_D577_4FC9_91D1_650A62EE7268__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// #include "GlobalLists.h"
#include "../../MyFrameAl5/Font/FontMenu.h"
#include "../../MyFrameAl5/Menu/MyMenu.h"
#include "../../MyFrameAl5/Game/GameSection.h"
#include "../../MyFrameAl5/Game/ListLivingObject.h"


////////////////////////////////////////////////////
//
// Game Type ( = on which score table it is written)
//               it may be different for the two players
//
////////////////////////////////////////////////////

#define CFG_GAMETYPE_1P					0 
#define CFG_GAMETYPE_2P_COOP			1 
#define CFG_GAMETYPE_2P_VS				2 

#define CFG__MAXGAMETYPES			1


///////////////////////////////////////////////////////
// 
// Game Mode ( it is global for the two players )
// 
///////////////////////////////////////////////////////

#define GAMEMODE_NONE			-1
#define GAMEMODE_SINGLE			0
#define GAMEMODE_COOP			1
#define GAMEMODE_BATTLE			2


///////////////////////////////////////////////////////
// 
// GRAPHICS DEFINES
// 
///////////////////////////////////////////////////////

#define LITCELLBITMAP_MAXLEVEL		100
#define LITCELLBITMAP_MAXSOURCES	7


#define LITCELLS_MAX_ROWS		15
#define LITCELLS_MAX_COLS		20
#define LITCELLS_MAX_ITEMS		300
#define LITCELL_IMAGE_W			8
#define LITCELL_SPR_W			32

#define LITCELL_LITMAX			16 // 8
#define LITCELL_MOVIENUM__MASK			0x7F
#define LITCELL_MOVIENUMFLG_REVERSE		0x80
#define LITCELL_MAXMOVIES		12 // 10
#define LITCELL_MOVIE_MAXSPRITESANIM	24 // 16


#define EXPLRECT_MAXMOVIES					6
#define EXPLRECT_IMAGE_W					24
#define EXPLRECT_IMAGE_H					16
#define EXPLRECT_COLL_W						64
#define EXPLRECT_COLL_H						48

#define EXPLRECT_MOVIE_NBLITSPRITES			5
#define EXPLRECT_MOVIE_NBDARKSPRITES		5
#define EXPLRECT_MOVIE_MAXSPRITESANIM		28


///////////////////////////////////////////////////////
// 
// MUSIC DEFINES
// 
///////////////////////////////////////////////////////

#define BEAT_PERIOD							24 // 64
											// BPM:150 period:24
											// BPM:120 period:30
											// BPM:100 period:36
	
///////////////////////////////////////////////////////
// 
// GAME DEFINES
// 
///////////////////////////////////////////////////////

#define ASTEROID_W					8
#define ASTEROID_IDLE_MINTIME		54
#define ASTEROID_IDLE_MAXTIME		134

#define MISSILEPLAYER_SPR_W			10
#define MISSILEPLAYER_COLL_W		16



typedef struct CellInfo_t
{
	unsigned char m_nAnimMaxTime;
	unsigned char m_nAnimCurrentTime;
	
	unsigned char m_nAnimMovieNum;	// mask  LITCELL_MOVIENUM__MASK
									// bit LITCELL_MOVIENUMFLG_REVERSE = display sprite backwards
	unsigned char m_nLitLevel;
	
}CellInfo_t;


#define CURSORANIM_ADDROT_IDLE					100
#define CURSORANIM_ADDROT_MOVE_MAX				800
#define CURSORANIM_ADDROT_FIRE					16384
#define CURSORANIM_ADDROT_SMOOTH				2000
#define CURSORANIM_KEEP_OLDPOS_MAX				100
#define CURSORANIM_FIRE_BUMP_TIME				20

extern unsigned short _nCursorRotTarget65536;
extern unsigned short _nCursorRotCurrent65536;
extern unsigned char _nCursorLastPressFire;

extern short _nCursorRotVelocity;


extern CellInfo_t* _nCellLitInfos; 
extern unsigned char _nCellLit_NextAdd;

extern unsigned short _nDayTime;
extern unsigned long _nTotalExeTime;
extern unsigned long _nNbAsteroidsSpawned;

extern unsigned char _nNextAsteroidCurrentTime;
extern unsigned char _nNextAsteroidMaxTime;


extern char _nNbMissilesLeft;
extern unsigned long _nScorePlayer;


#define CAMERA_MAXTIME_PER_TILE16		4

extern float _fCameraOffsetCurrentX;
extern float _fCameraOffsetTargetX;
extern float _fCameraOffsetOldX;
extern unsigned char _nCameraAnimCurrentTime;
extern unsigned char _nCameraAnimMaxTime;

extern float NORMALIZED_POSX_MIN;
extern float NORMALIZED_POSX_MAX;
extern float ORIGINAL_POSX_MAX;
extern float ORIGINAL_POSX_MIN;




extern CListLivingObject* _pListAsteroids;
extern CListLivingObject* _pListMyPlayerMissiles;
extern CListLivingObject* _pListMyPlayerExplosions;

#define MAX_CITIES					64
#define CITY_YMAX					464
#define CITY_YMIN					430
#define CITY_WMIN					32
#define CITY_WMAX					48
#define CITY_HMIN					64
#define CITY_HMAX					96

extern CListLivingObject* _pListCities;


#define GROUND_SHIELD_SPR_W			160
#define GROUND_SHIELD_SPR_H			8
#define GROUND_SHIELD_IMAGE_W		40
#define GROUND_SHIELD_IMAGE_H		4
#define GROUND_SHIELD_MAXSPRITENUM		16

extern float _fGroundLimitYCurrent;
extern float _fGroundLimitYTarget;
extern float _fGroundLimitDisplayedLives;
extern float _fGroundLimitLives;
extern bool _bDead;
extern unsigned char _nLastCollideExplosion;

///////////////////////////////////////////////////////




class CMyGameHelper; // predec



//////////////////////////////////////////////////////////////////////

class CMyGameHelper : public CGameHelper  
{
public:
	
	CMyGameHelper(int nDispFlags=0xFFFFFFFF);
	virtual ~CMyGameHelper();

protected:	
	int DoBeginGame_Ex();
	// Should use CJoinEngine instead // void DoTryJoin_Ex(char& nJoin, CMyMenu* pMenu, CMyMenuEngine* pEngine, char NEW_VAL);
	// Should use CJoinEngine instead // bool IsBattleMode();
	// Should use CJoinEngine instead // void InitMenuJoin();
	// Should use CJoinEngine instead // void DeleteMenuJoin();	
public:	

public:
	bool IsPlayerFireAllowed();
	bool IsPlayerTimeCounted();
	bool IsEnemyMoveAllowed();
	bool IsPlayerStatusUpdateAllowed();
	bool IsMetricsTimeCounted();	
	bool IsStageCleared();

	// Should use CJoinEngine instead // void DrawMenuJoin();

protected:
	




protected:
	virtual void V_DrawTextsOnScreen();
	virtual void V_DrawGamePlay();
	virtual void OnSectionChange();
	virtual void V_Cheat_GoToClear();
	virtual void OnSectionLoop();
	// virtual game methods
	virtual int V_DoGamePlay( bool bIsRealGame );	
	virtual void V_DrawAnySection();

	virtual int V_DoStageClear(); // for example, place here a CANCEL_BULLET or a KILL_ALL_ENEMIES

	virtual int V_DoBeginGame( bool bRealGame );
	virtual int V_DoEndGame(bool bAborted);
	virtual int V_DoEndStage();
	virtual int V_DoBeginStage();
	virtual void V_DoSaveGameStats();

	// Should use CJoinEngine instead // virtual int V_DoInitJoin();
	// Should use CJoinEngine instead // virtual int V_DoTryJoin(char nPlayerNum);

public:
	virtual void Draw();
	virtual char GetGameTypeForPlayer(char nPlayerNum);

};

#endif // !defined(AFX_MYGAMEHELPER_H__8E57A6B0_D577_4FC9_91D1_650A62EE7268__INCLUDED_)
