/***************************************************************************/
/*                                                                         */
/*                      M Y L I V I N G O B J E C T                        */
/*                                                                         */
/***************************************************************************/




#include "MyLivingObject.h"
//#include "MyBullet.h"
//#include "MyBulletWave.h"
//#include "MyGameObjects.h"
#include "PlayerEntity.h"
#include "../../MyFrameAl5/Game/ExplosionPart.h"
#include "../../MyFrameAl5/FrameGlobalVars.h"
#include "../../MyFrameAl5/Math/CalcHelper.h"
#include "../../MyFrameAl5/Draw/MovInfoText.h"
#include "../../MyFrameAl5/Game/Player.h"
#include "MyGameHelper.h"

void _score_extendPlayer(void* pParentPlayer)
{
	((CLivingObject*)pParentPlayer)->m_nLivesCount++;
	// TODO: Sound
}

long _score_getNextExtendPlayer(char nExtendsGot)
{
	long nNext = 1e7;
	nNext <<= (nExtendsGot);
	return nNext;	
}

void _score_addProgressiveScore(Score_t *nScoreDisplay, Score_t nScoreTarget)
{
	CalcAddProgressiveValue(DATATYPE_INT64, nScoreDisplay, nScoreTarget, 3900, 23900, 53900, 73900);
	// TODO
}

float _score_getHitMultiply(short nHits)
{	
	float fRet = 0;
	char nPart = 1;
	long nAdd;

	nHits = MIN(nHits, COMBO_HITMAX);

	/*
#define COMBO_MULTIPLY_PART1		10
#define COMBO_HITPART				10
#define COMBO_HITMAX				50
#define COMBO_MULTIPLY_MAX			64
	// 1,2,3,4,5,6,7,8,9,10
	// 12,14,16,18,20,22,24,26,28,30
	// 33,36,39,42,45,48,51,54,57,60
	// 64,64,64(MAX)
	*/
	while (nHits > 0)
	{
		nAdd = MIN(nHits, COMBO_HITPART)*nPart*COMBO_MULTIPLY_PART1/COMBO_HITPART;
		ASSERT(nAdd > 0);
		fRet += nAdd;
		nPart++;
		nHits -= COMBO_HITPART;
	}
	
	fRet = MIN(fRet, COMBO_MULTIPLY_MAX);

	ASSERT(fRet >= 1.0f || nHits == 0); // "0 hit" must be X0
	ASSERT(fRet == 1.0f || nHits != 1); // "1 hit" must be X1
	return fRet;
}

void _score_spawnHitMovInfoText(int nNominalPoints, float fMultiply, const char* szText, CAnimMovObject* pOriginObject, float fx, float fy, float fScale)
{
	if (pOriginObject != NULL)
	{
		fx = pOriginObject->m_fX;
		fy = pOriginObject->m_fY;
	}

	//CMovInfoText* pInfoText = new CMovInfoText();
	//pInfoText->Init_MovInfoText_WithFontText(
	//	szText, nNominalPoints, fMultiply, fx, fy, fScale, false, _pFontNormal);
	//_pListInfoTexts->Add(pInfoText);
}

float _score_getGrindMultiply(short nHits)
{
	return 1.0f + 0.1f*nHits;
}

void _score_spawnGrindMovInfoText(int nNominalPoints, float fMultiply, const char* szText, CAnimMovObject* pOriginObject, float fx, float fy, float fScale)
{
	if (pOriginObject != NULL)
	{
		fx = pOriginObject->m_fX;
		fy = pOriginObject->m_fY;
	}

	//char szBuf[8] = "B";
	//	
	//_pListInfoTexts->Add( 
	//	(CMyObject*)( new CMovInfoText(
	//		szBuf, 0, fMultiply, fx, fy, fScale) )
	//	);		
}

//void ConvertXYIntoGridPos(float fx, float fy, char& nCol, char& nRow)
//{
//	nCol = fx / BLOC_SPR_W;
//	nRow = fy / BLOC_SPR_W;
//}
//
//void ConvertGridPosIntoXY(char nTileCol, char nTileRow, float& m_fX, float& m_fY)
//{
//	m_fX = nTileCol*BLOC_SPR_W + 0.5f*BLOC_SPR_W;
//	m_fY = nTileRow*BLOC_SPR_W + 0.5f*BLOC_SPR_W;
//}
//
//bool IsPosEmpty(char nTileCol, char nTileRow)
//{
//	if (   nTileCol <= TILEAREA_COL_MIN || nTileCol >= TILEAREA_COL_MAX 
//		|| nTileRow <= TILEAREA_ROW_MIN || nTileRow >= TILEAREA_ROW_MAX)
//		return false;
//
//	if (   nTileCol >= 9 && nTileCol <= 10
//		&& nTileRow >= 7 && nTileRow <= 8)
//		return false;
//
//	if (   nTileCol == 5 && nTileRow == 3)
//		return false;
//
//	if (   nTileCol == 14 && nTileRow == 11)
//		return false;
//
//	return true;
//}

/*-------------------------------------------------------------------------*/
/*---------------------------- CMy Living Object --------------------------*/
/*-------------------------------------------------------------------------*/
CMyLivingObject::CMyLivingObject():CLivingObject()
{
}
  
/*-------------------------------------------------------------------------*/
/*-------------------------- ~ CMy Living Object --------------------------*/
/*-------------------------------------------------------------------------*/
CMyLivingObject::~CMyLivingObject()
{
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Is Disposable ----------------------------*/
/*-------------------------------------------------------------------------*/
bool CMyLivingObject::IsDisposable()
{
	if (m_fLife <= 0.0f)
		return true;

	return CLivingObject::IsDisposable();
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Is Collidable ----------------------------*/
/*-------------------------------------------------------------------------*/
bool CMyLivingObject::IsCollidable()
{
	return true;
}

/*-------------------------------------------------------------------------*/
/*---------------------------- Init Player Props --------------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::InitPlayerProps(char nJoypadNum, CLivingObject* pLivingObj)
{
	ASSERT(m_pPlayerProps == NULL);
	m_pPlayerProps = new CPlayerProperties(pLivingObj);
	m_pPlayerProps->m_pJoypad = _pListJoypadConfig->GetPreferredJoypad_Side(nJoypadNum);

	m_pPlayerProps->m_pScore = new CScore();
	m_pPlayerProps->m_pScore->Init_ComboHit(600, 8, 240, _score_getHitMultiply, _score_spawnHitMovInfoText);
	m_pPlayerProps->m_pScore->Init_ComboGrind(600, 8, 240, _score_getGrindMultiply, _score_spawnGrindMovInfoText);
	m_pPlayerProps->m_pScore->Init_Base(/*bIsRealGame=*/true, this,
		_score_getNextExtendPlayer,
		_score_extendPlayer,
		_score_addProgressiveScore);	

	m_pPlayerProps->m_pJoypad = _pListJoypadConfig->GetPreferredJoypad_Side(m_pPlayerProps->GetPlayerSide());

	m_pPlayerProps->Validate();

	//if (bIsRealGame)
		m_pPlayerProps->m_pScore->BeginGame();	
}

/*-------------------------------------------------------------------------*/
/*---------------------- VGet Default Target Type Ex ----------------------*/
/*-------------------------------------------------------------------------*/
/*virtual*/ char CMyLivingObject::V_GetLivingObjectDefaultTargetType_Ex(int nOwnerType, int nObjectType)
{
	switch (nOwnerType)
	{
	case OWNER_PLAYER1:
	case OWNER_PLAYER2:
	case OWNER_PLAYERUNKNOWN:
		return TARGET_ENEMYTYPE1;
		break;

	case OWNER_CPU:
		return TARGET_PLAYER1 + rand()%2;
	}
	ASSERT(FALSE);
	return TARGET_PLAYERUNKNOWN;
}

/*-------------------------------------------------------------------------*/
/*----------------------------- VCreate Bullet ----------------------------*/
/*-------------------------------------------------------------------------*/
/*virtual*/ CBullet* CMyLivingObject::V_CreateBullet()
{
	//ASSERT(HasLivesLeft());
	//CMyBullet* pMyBullet = new CMyBullet();
	//return (CBullet*)pMyBullet;
	return NULL;
}

/*-------------------------------------------------------------------------*/
/*--------------------------- VCreate BulletWave --------------------------*/
/*-------------------------------------------------------------------------*/
/*virtual*/ CBulletWave* CMyLivingObject::V_CreateBulletWave()
{
	//ASSERT(HasLivesLeft());
	//CMyBulletWave* pMyBulletWave = new CMyBulletWave();
	//return (CBulletWave*)pMyBulletWave;
	return NULL;
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Reward Owner -----------------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::RewardOwner_Kill(CLivingObject* pDeadEntity)
{
	// Nothing.
	// Only the Bullet rewards its owner
}

/*-------------------------------------------------------------------------*/
/*---------------------------- Reward Owner Hit ---------------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::RewardOwner_Hit(CLivingObject* pDeadEntity)
{
	// Nothing.
	// Only the Bullet rewards its owner
}

/*-------------------------------------------------------------------------*/
/*------------------------ Spawn Explosion When Hit -----------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::SpawnExplosionWhenHit()
{
	// Explosion already created when MyBullet is killed
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Spawn Vanish -----------------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::SpawnExplosionWhenVanish()
{
	//CExplosionPart::CreateExplosionPart_OnLivingObject(this, MOVIEID_EXPLVANISH, true);
}

/*-------------------------------------------------------------------------*/
/*------------------------------ Original Move ----------------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::OriginalMove()
{
	m_fY += m_fDy;
	m_fOriginalX += m_fDx;
	if (m_fOriginalX > ORIGINAL_POSX_MAX)
	{
		m_fOriginalX = ORIGINAL_POSX_MIN + m_fOriginalX - ORIGINAL_POSX_MAX;
	}
	else if (m_fOriginalX < ORIGINAL_POSX_MIN)
	{
		m_fOriginalX = ORIGINAL_POSX_MAX + m_fOriginalX - ORIGINAL_POSX_MIN;
	}
}

/*-------------------------------------------------------------------------*/
/*---------------------------- Update Screen Pos --------------------------*/
/*-------------------------------------------------------------------------*/
void CMyLivingObject::UpdateScreenPos()
{
	m_fX = ConvertOriginalToNormalizedPos_Ex(m_fOriginalX);
}

/*-------------------------------------------------------------------------*/
/*------------------ Convert Normalized To Original Pos Ex ----------------*/
/*-------------------------------------------------------------------------*/
float CMyLivingObject::ConvertNormalizedToOriginalPos_Ex(float fNormalizedX)
{
	float fOriginalX = fNormalizedX + _fCameraOffsetCurrentX - 0.5f*BITMAP_W;

	if (fOriginalX > ORIGINAL_POSX_MAX)
	{
		fOriginalX = ORIGINAL_POSX_MIN + fOriginalX - ORIGINAL_POSX_MAX;
	}
	else if (fOriginalX < ORIGINAL_POSX_MIN)
	{
		fOriginalX = ORIGINAL_POSX_MAX + fOriginalX - ORIGINAL_POSX_MIN;
	}
	return fOriginalX;
}

/*-------------------------------------------------------------------------*/
/*------------------ Convert Original To Normalized Pos Ex ----------------*/
/*-------------------------------------------------------------------------*/
float CMyLivingObject::ConvertOriginalToNormalizedPos_Ex(float fOriginalX)
{
	float fNormalizedX = fOriginalX - _fCameraOffsetCurrentX + 0.5f*BITMAP_W;

	if (fNormalizedX > NORMALIZED_POSX_MAX)
	{
		fNormalizedX = NORMALIZED_POSX_MIN + fNormalizedX - NORMALIZED_POSX_MAX;
	}
	else if (fNormalizedX < NORMALIZED_POSX_MIN)
	{
		fNormalizedX = NORMALIZED_POSX_MAX + fNormalizedX - NORMALIZED_POSX_MIN;
	}
	return fNormalizedX;
}
