/***************************************************************************/
/*                                                                         */
/*                                I N I T                                  */
/*                                                                         */
/***************************************************************************/



#include "../../MyFrameAl5/File/ConfigFile.h"
#include "../../MyFrameAl5/Data/Datatypes.h"
#include "../../MyFrameAl5/Menu/MyMenu.h"
#include "../../MyFrameAl5/Math/MyRand.h"
#include "../../MyFrameAl5/Math/CalcHelper.h"
#include "../../MyFrameAl5/Font/FontMenu.h"
#include "../../MyFrameAl5/Prj/Prj.h"
#include "../../MyFrameAl5/Menu/MenuDebugCommon.h"
#include "../../MyFrameAl5/FrameGlobalVars.h"
#include "init.h"
#include "GlobalDefs.h"
#include "MyJoinEngine.h"
#include "MyGameHelper.h"
#include "MyLivingObject.h"
#include "layout.h"
#include "MyObj.h"


/*-------------------------------------------------------------------------*/
/*------------------------------ Init config ------------------------------*/
/*-------------------------------------------------------------------------*/
int my_init_config(int nVersion)
{
	unsigned short nHeadBytes;
	int nCurrentPos;
	
	switch (nVersion)
	{
	case 1:
		ASSERT(FALSE);
		break;

	case 2:
		nHeadBytes = 64;
		_pConfig->m_nFileHeadSize = nHeadBytes;
		
		// Head Block /////////////////////////////////
		nCurrentPos = 0;
		_pConfig->AddConfigVar(DATATYPE_INT8	,     0, NULL,	&(_pConfig->m_nInputDataVersion),	-1, true);
		nCurrentPos = 8; // Set to 8
		_pConfig->AddConfigVar(DATATYPE_UINT32	,  nCurrentPos, NULL,	&(_pConfig->m_nFileTotalSize)	,	-1, true);
		nCurrentPos += 4;
		_pConfig->AddConfigVar(DATATYPE_UINT16	,  nCurrentPos, NULL,	&(_pConfig->m_nFileHeadSize)	,	-1, true);
		nCurrentPos += 2;		
		_pConfig->AddConfigVar(DATATYPE_FILEBLOCK, nCurrentPos, NULL,	&(_pConfig->m_BlockConfig)		,	-1, true);
		nCurrentPos += FILEBLOCK_SIZE;

		// Config Block /////////////////////////////////
		ASSERT(nHeadBytes >= nCurrentPos);
		nCurrentPos = nHeadBytes;
		_pConfig->StartBlock(&(_pConfig->m_BlockConfig), nCurrentPos);

		/*
		_pConfig->AddConfigVar(DATATYPE_FLOAT, nCurrentPos, "GGapw", &GROUP_GAP_W);   nCurrentPos += sizeof(float);
		_pConfig->AddConfigVar(DATATYPE_FLOAT, nCurrentPos, "GGaph", &GROUP_GAP_H);   nCurrentPos += sizeof(float);
		_pConfig->AddConfigVar(DATATYPE_FLOAT, nCurrentPos, "Invw", &INVADER_W);   nCurrentPos += sizeof(float);
		_pConfig->AddConfigVar(DATATYPE_FLOAT, nCurrentPos, "Invh", &INVADER_H);   nCurrentPos += sizeof(float);
		*/
		
		_pConfig->EndBlock(&(_pConfig->m_BlockConfig), nCurrentPos);		

		break;

	}

	return nCurrentPos;
}

/*-------------------------------------------------------------------------*/
/*-------------------------------- Init menu ------------------------------*/
/*-------------------------------------------------------------------------*/
void init_menu_specific()
{
	//CMyMenu* pMenuGlobal	= new CMyMenu("CONFIG"	, 0, 64,  20, 64, 1.0f, 1.0f, MENUDRAWFLG_FORMAT);
	////CMyMenu* pMenuDebug	= new CFontMenu(_pFontNormal, "Specific Debug"			, 0, 64,  20, 64, 1.0f, 1.0f, MENUDRAWFLG_FORMAT);

	//_pMenuServiceMode->addSubMenu("", pMenuGlobal);
	
	//pMenuGlobal->add("Min DayTime", &(_nDayCycleTimeMin), DATATYPE_UINT8, "%d", 10,  25, 1);
	///*pMenuGlobal->add("Config2(ui8)", &(TEST_CFG2), DATATYPE_UINT8, "%d", 5, 10, 1);
	//pMenuGlobal->AddSeparator();
	//pMenuGlobal->add("Config3(f)", &(TEST_CFG3), DATATYPE_FLOAT, "%.0f",    0,  80, 2);
	//*/
	//pMenuGlobal->AddSeparator();
	//pMenuGlobal->addSubMenu("Spec Debug...", pMenuDebug);	
	
	//pMenuDebug->add("Config4(f)", &(TEST_CFG4), DATATYPE_FLOAT, "%.0f", -100, 100, 2);
	//pMenuDebug->AddSeparator();
	//pMenuDebug->addBackMenu();	


	//pMenuGlobal->AddSeparator();
	//pMenuGlobal->addBackMenu();	// pMenuGlobal->add("Done...", &_stop_menu_options , DATATYPE_FUNCPTR , NULL	,	  0, 0,	0);

	//pMenuGlobal->SetBackShadeAuto(true);
	//pMenuDebug->SetBackShadeAuto(true);

	_pMenuServiceMode->AddSeparator();
	_pMenuServiceMode->addBackMenu("Done.");

	_pMenuEngine->SetStartMenu(_pMenuServiceMode);
	_pMenuEngine->SetHighlightGrad((CGradient*)_pListGradients->GetItemByName("BG_DAY0"), 20);
	// _pMenuEngine->SetArrowSprite(MOVIEID_DIRARROW);


	/*--- Gameplay menu ---------------------------------------------------*/

	
}

/*-------------------------------------------------------------------------*/
/*--------------------------- Init game sections --------------------------*/
/*-------------------------------------------------------------------------*/
void init_game_sections()
{
	ASSERT(_pListEnemies != NULL);
	ASSERT(_pListMissilesCpu != NULL);

	NORMALIZED_POSX_MIN = -0.1f*BITMAP_W;
	NORMALIZED_POSX_MAX = BITMAP_W - 2.0f*NORMALIZED_POSX_MIN;
	ORIGINAL_POSX_MAX	= NORMALIZED_POSX_MAX - NORMALIZED_POSX_MIN;
	ORIGINAL_POSX_MIN	= 0.0f;
	_fGroundLimitYCurrent = BITMAP_H;
	_fGroundLimitDisplayedLives = 0.0f;

	time_t tTheTime;
	time(&tTheTime);
	_nDayTime = tTheTime*86400/120;

	_pListAsteroids = new CListLivingObject(32, false);
	_pListMyPlayerMissiles = new CListLivingObject(32, false);
	_pListMyPlayerExplosions = new CListLivingObject(32, false);
	_pListCities = new CListLivingObject(MAX_CITIES, false);

	// Create the City list ONCE ("Game Legacy" http://globalgamejam.org/news/and-ggj17-diversifiers-are)

	int i = 0;
	for (; i<MAX_CITIES/2; i++)
	{
		CCityRect* pCity = new CCityRect();
		pCity->Init( ORIGINAL_POSX_MIN + i*(ORIGINAL_POSX_MAX-ORIGINAL_POSX_MIN)/(MAX_CITIES/2) + rand()%16);
		_pListCities->Add(pCity);
	}

	for (; i<MAX_CITIES; i++)
	{
		CCityRect* pCity = new CCityRect();
		pCity->Init( GetRandInt_MinMax(ORIGINAL_POSX_MIN, ORIGINAL_POSX_MAX) );
		_pListCities->Add(pCity);
	}


	//short INTROTITLE_TIME = 600;
	// short PAGECONTROLS_TIME = 600;
	//short GAMESTAGEINIT_TIME = 120;

	_pGameHelper = new CMyGameHelper();
	

	_pGameHelper->Add( new CGameSection(SCTN_INITSCREEN	, GAMESCTNTYPE_INIT, GAMESEQMODE_TIMEOUT,	BEAT_PERIOD) );
	//_pGameHelper->Add( new CGameSection(SCTN_WARNING	, GAMESCTNTYPE_INIT, GAMESEQMODE_TIMEOUT,	PAGEWARNING_TIME) );
	//_pGameHelper->Add( new CGameSection(SCTN_WARNING2	, GAMESCTNTYPE_INIT, GAMESEQMODE_TIMEOUT,	PAGEWARNING_TIME) );

	//_pGameHelper->Add( new CGameSection(SCTN_PRETITLE	, GAMESCTNTYPE_INIT, GAMESEQMODE_TIMEOUT,	2) );
	_pGameHelper->Add( new CGameSection(SCTN_TITLE		, GAMESCTNTYPE_DEAD, GAMESEQMODE_TIMEOUT,	600) );
	//_pGameHelper->Add( new CGameSection(SCTN_DEMO		, GAMESCTNTYPE_DEAD, GAMESEQMODE_TIMEOUT,	700,	SCTNDISPFLG_DISPGAMEPLAY) );
	//_pGameHelper->Add( new CGameSection(SCTN_CONTROLS	, GAMESCTNTYPE_DEAD, GAMESEQMODE_TIMEOUT,	PAGECONTROLS_TIME,	SCTNDISPFLG_DISPGAMEPLAY) );

	//_pGameHelper->Add( new CGameSection(SCTN_JOINMENU1	, GAMESCTNTYPE_JOIN, GAMESEQMODE_STATIC,	0) );

	//_pGameHelper->Add( new CGameSection(SCTN_GAMESTAGEINIT	, GAMESCTNTYPE_PLAY, GAMESEQMODE_TIMEOUT,	GAMESTAGEINIT_TIME,	SCTNDISPFLG_DISPGAMEPLAY) ); 
	_pGameHelper->Add( new CGameSection(SCTN_GAMEPLAY		, GAMESCTNTYPE_PLAY, GAMESEQMODE_STATIC	,	0		, SCTNDISPFLG_DISPGAMEPLAY) );

	//_pGameHelper->Add( new CGameSection(SCTN_CLEAR_INIT		, GAMESCTNTYPE_STGCLEAR, GAMESEQMODE_TIMEOUT, 90, SCTNDISPFLG_DISPGAMEPLAY) );
	//_pGameHelper->Add( new CGameSection(SCTN_CLEAR_STATS	, GAMESCTNTYPE_STGCLEAR, GAMESEQMODE_IDLE, 60, SCTNDISPFLG_DISPGAMEPLAY) );
	//_pGameHelper->Add( new CGameSection(SCTN_GOTONEXTSTAGE	, GAMESCTNTYPE_STGCLEAR, GAMESEQMODE_TIMEOUT, 210, SCTNDISPFLG_DISPGAMEPLAY) );

	//_pGameHelper->Add( new CGameSection(SCTN_NAMEENTRY		, GAMESCTNTYPE_GAMEOVER, GAMESEQMODE_TIMEOUT,	0		, SCTNDISPFLG_DISPGAMEPLAY) );
	//_pGameHelper->Add( new CGameSection(SCTN_GAMERESULTS1	, GAMESCTNTYPE_GAMEOVER, GAMESEQMODE_TIMEOUT,	0		, SCTNDISPFLG_DISPGAMEPLAY) );
//	_pGameHelper->Add( new CGameSection(SCTN_GAMERESULTS2	, GAMESCTNTYPE_GAMEOVER, GAMESEQMODE_TIMEOUT) );
	_pGameHelper->Add( new CGameSection(SCTN_GAMEOVER		, GAMESCTNTYPE_GAMEOVER, GAMESEQMODE_TIMEOUT,	300, SCTNDISPFLG_DISPGAMEPLAY) );

	_pGameHelper->Normalize();
	_pGameHelper->SetGameTypeNames(
		"_A|_B|_C");
}



/*-------------------------------------------------------------------------*/
/*------------------------ Create Bitmaps Lit Cells -----------------------*/
/*-------------------------------------------------------------------------*/
void CreateBitmaps_LitCells()
{
	unsigned char nMovieNum;
	unsigned char nGrid[LITCELL_IMAGE_W][LITCELL_IMAGE_W], *pTmpGrid;
	unsigned char nNeighborGrid[LITCELL_IMAGE_W][LITCELL_IMAGE_W];
	char srcx[LITCELLBITMAP_MAXSOURCES];
	char srcy[LITCELLBITMAP_MAXSOURCES];
	unsigned char SRC_LIT = 32;
	unsigned char NEIGHBOR_LIT_DIRECT = 4; // 10
	unsigned char NEIGHBOR_LIT_DIAG = 1; // 3
	unsigned char NEIGHBOR_SPRITE0 = 0.7f*LITCELL_MOVIE_MAXSPRITESANIM;
	unsigned char RAND_LITMIN = 5; // 2;
	unsigned char RAND_LITMAX = 10; // 4;
	char nSrcNewX, nSrcNewY;
	
	ALLEGRO_BITMAP* bmpTmp = al_create_bitmap(LITCELL_IMAGE_W*LITCELL_MOVIE_MAXSPRITESANIM, LITCELL_IMAGE_W);
	
	
	
	for (nMovieNum=0; nMovieNum< LITCELL_MAXMOVIES; nMovieNum++)
	{
		memset(&nGrid[0][0], 0, LITCELL_IMAGE_W*LITCELL_IMAGE_W);
		unsigned char nSrcNum, nNbSources = 1;
		unsigned char nSpriteNum;
		
		
		srcx[0] = GetRandInt_MinMax(1, LITCELL_IMAGE_W-2);
		srcy[0] = GetRandInt_MinMax(1, LITCELL_IMAGE_W-2);
		
		al_set_target_bitmap(bmpTmp);
		al_clear_to_color(COL_ZEROALPHA);
		al_lock_bitmap(bmpTmp, ALLEGRO_PIXEL_FORMAT_ANY, ALLEGRO_LOCK_WRITEONLY);
		
		for (nSpriteNum = 0; nSpriteNum < LITCELL_MOVIE_MAXSPRITESANIM; nSpriteNum++)
		{
			// detect neighbors
			if (nSpriteNum >= NEIGHBOR_SPRITE0)
			{
				unsigned char nColDiag;
				memset(nNeighborGrid, 0, LITCELL_IMAGE_W*LITCELL_IMAGE_W);
			
				for (nSrcNewY=0; nSrcNewY<LITCELL_IMAGE_W; nSrcNewY++)
				{
					for (nSrcNewX=0; nSrcNewX<LITCELL_IMAGE_W; nSrcNewX++)
					{
						unsigned char nColDirect = nGrid[nSrcNewX][nSrcNewY];
						if (nColDirect > 0)
						{
							if (nColDirect >= NEIGHBOR_LIT_DIRECT)
							{
								nColDirect = NEIGHBOR_LIT_DIRECT;
								nColDiag = NEIGHBOR_LIT_DIAG;
							}
							else 
							{
								nColDiag = nColDirect*NEIGHBOR_LIT_DIAG/NEIGHBOR_LIT_DIRECT;
							}
							
							if (nSrcNewX > 0) nNeighborGrid[ nSrcNewX-1 ][ nSrcNewY   ] += nColDirect;
							if (nSrcNewY > 0) nNeighborGrid[ nSrcNewX   ][ nSrcNewY-1 ] += nColDirect;
							if (nSrcNewX < LITCELL_IMAGE_W-1) nNeighborGrid[ nSrcNewX+1 ][ nSrcNewY   ] += nColDirect;
							if (nSrcNewY < LITCELL_IMAGE_W-1) nNeighborGrid[ nSrcNewX   ][ nSrcNewY+1 ] += nColDirect;
							
							if (nSrcNewX > 0 && nSrcNewY > 0) nNeighborGrid[ nSrcNewX-1 ][ nSrcNewY-1 ] += nColDiag;
							if (nSrcNewX > 0 && nSrcNewY < LITCELL_IMAGE_W-1) nNeighborGrid[ nSrcNewX-1 ][ nSrcNewY+1 ] += nColDiag;
							if (nSrcNewX < LITCELL_IMAGE_W-1 && nSrcNewY > 0) nNeighborGrid[ nSrcNewX+1 ][ nSrcNewY-1 ] += nColDiag;
							if (nSrcNewX < LITCELL_IMAGE_W-1 && nSrcNewY < LITCELL_IMAGE_W-1) nNeighborGrid[ nSrcNewX+1 ][ nSrcNewY+1 ] += nColDiag;
						}
					}
				}
				
				// apply neighbors 
				
				for (nSrcNewY=0; nSrcNewY<LITCELL_IMAGE_W; nSrcNewY++)
				{
					for (nSrcNewX=0; nSrcNewX<LITCELL_IMAGE_W; nSrcNewX++)
					{
						nGrid[nSrcNewX][nSrcNewY] += nNeighborGrid[nSrcNewX][nSrcNewY];
						nGrid[nSrcNewX][nSrcNewY] = MIN(nGrid[nSrcNewX][nSrcNewY], LITCELLBITMAP_MAXLEVEL);
					}
				}
			}
			
			// spawn new sources
		
			switch (nSpriteNum)
			{
			case 2:
			case 6:
			case 10:
				ASSERT(nNbSources < LITCELLBITMAP_MAXSOURCES);
				nSrcNewX = srcx[nNbSources-1] + rand()%3 - 1;
				nSrcNewY = srcx[nNbSources-1] + rand()%3 - 1;
				srcx[nNbSources] = CLAMP(0, nSrcNewX, LITCELL_IMAGE_W-1);
				srcy[nNbSources] = CLAMP(0, nSrcNewY, LITCELL_IMAGE_W-1);
				ASSERT(srcx[nNbSources] >= 0 && srcx[nNbSources] < LITCELL_IMAGE_W);
				ASSERT(srcy[nNbSources] >= 0 && srcy[nNbSources] < LITCELL_IMAGE_W);
				nNbSources++;
				break;

			case 4:
			case 8:
			case 12:
				ASSERT(nNbSources < LITCELLBITMAP_MAXSOURCES);
				srcx[nNbSources] = rand()%LITCELL_IMAGE_W;
				srcy[nNbSources] = rand()%LITCELL_IMAGE_W;
				nNbSources++;
				break;
			}
			
			// color the sources
			
			for (nSrcNum=0; nSrcNum < nNbSources; nSrcNum++)
			{
				ASSERT(srcx[nSrcNum] >= 0 && srcx[nSrcNum] < LITCELL_IMAGE_W);
				ASSERT(srcy[nSrcNum] >= 0 && srcy[nSrcNum] < LITCELL_IMAGE_W);
				pTmpGrid = &nGrid[ srcx[nSrcNum] ][ srcy[nSrcNum] ];
				(*pTmpGrid) += SRC_LIT;
				*pTmpGrid = MIN(*pTmpGrid, LITCELLBITMAP_MAXLEVEL);
				
				// move the source
				do
				{
					nSrcNewX = srcx[nSrcNum];
					nSrcNewY = srcy[nSrcNum];
					switch (rand()%4)
					{
					case 0: nSrcNewX++; break;
					case 1: nSrcNewX--; break;
					case 2: nSrcNewY++; break;
					case 3: nSrcNewY--; break;
					}
				}while (nSrcNewX < 0 || nSrcNewY < 0 || nSrcNewX >= LITCELL_IMAGE_W || nSrcNewY >= LITCELL_IMAGE_W);
				
				ASSERT(nSrcNewX >= 0 && nSrcNewX < LITCELL_IMAGE_W);
				ASSERT(nSrcNewY >= 0 && nSrcNewY < LITCELL_IMAGE_W);
				srcx[nSrcNum] = nSrcNewX;
				srcy[nSrcNum] = nSrcNewY;
			}
			
			
			// color slightly some random points
			
			for (nSrcNum=0; nSrcNum < 5; nSrcNum++)
			{
				nSrcNewX = rand()%LITCELL_IMAGE_W;
				nSrcNewY = rand()%LITCELL_IMAGE_W;
				pTmpGrid = &nGrid[nSrcNewX][nSrcNewY];
				(*pTmpGrid) += GetRandInt_MinMax(RAND_LITMIN, RAND_LITMAX);
				*pTmpGrid = MIN(*pTmpGrid, LITCELLBITMAP_MAXLEVEL);
			}
			
			// dump to pixels
			
			for (nSrcNewY=0; nSrcNewY<LITCELL_IMAGE_W; nSrcNewY++)
			{
				for (nSrcNewX=0; nSrcNewX<LITCELL_IMAGE_W; nSrcNewX++)
				{
					unsigned char nLit = nGrid[nSrcNewX][nSrcNewY];
					
					if (nLit > 0)
					{
						nLit = nLit*255/LITCELLBITMAP_MAXLEVEL;
						al_put_pixel(
							  nSrcNewX + LITCELL_IMAGE_W*nSpriteNum
							, nSrcNewY
							, al_map_rgba(0,0,0, nLit)
						);
					}
				}
			}
		}
		
		al_unlock_bitmap(bmpTmp);
		
		CMovieClip* pMovieClip = new CMovieClip();
		ASSERT(pMovieClip != NULL);
		pMovieClip->CreateFromBitmap_Multi_ImageWidth(bmpTmp, NULL, LITCELL_IMAGE_W,
			NULL, SPRINIT_HASALREADYALPHA, ANIM_FORWARD);
		pMovieClip->InitVars_Fps(-1, 1);
		_pListMovieClips->Add_andAffectExternalId(pMovieClip, MOVIEID_LITCELL0 + nMovieNum);
	}

	
	al_destroy_bitmap(bmpTmp);
	_pListMovieClips->SetSearchIndexes();	
}

/*-------------------------------------------------------------------------*/
/*------------------------ Create Bitmaps Expl Rects ----------------------*/
/*-------------------------------------------------------------------------*/
void CreateBitmaps_ExplRects()
{
	unsigned char nGrid[EXPLRECT_IMAGE_W][EXPLRECT_IMAGE_H];
	
	ALLEGRO_BITMAP* bmpTmp = al_create_bitmap(EXPLRECT_IMAGE_W*EXPLRECT_MOVIE_MAXSPRITESANIM, EXPLRECT_IMAGE_H);
	
	for (unsigned char nMovieNum=0; nMovieNum< EXPLRECT_MAXMOVIES; nMovieNum++)
	{
		memset(nGrid, 0xFF, EXPLRECT_IMAGE_W*EXPLRECT_IMAGE_H);
		
		char nSpriteNum;
		char nCenterX = (0.3f + 0.4f*(nMovieNum/2)/(EXPLRECT_MAXMOVIES/2 - 1))*EXPLRECT_IMAGE_W;
		char nCenterY = (0.3f + 0.4f*(nMovieNum%2))*EXPLRECT_IMAGE_H;
		char nRadius = -1;
		unsigned char nMinLit = 255;
		unsigned char nMaxLit = 255;
		unsigned char nDiffLit;
		unsigned char nAlphaLevel = 255;
		char nx, ny;
		unsigned char nAddLitMax = 512/EXPLRECT_MOVIE_MAXSPRITESANIM;
		
		al_set_target_bitmap(bmpTmp);
		al_clear_to_color(COL_ZEROALPHA);
		al_lock_bitmap(bmpTmp, ALLEGRO_PIXEL_FORMAT_ANY, ALLEGRO_LOCK_WRITEONLY);
		
		for (nSpriteNum = 0; nSpriteNum < EXPLRECT_MOVIE_MAXSPRITESANIM; nSpriteNum++)
		{
			unsigned short nMovieXOffset = nSpriteNum*EXPLRECT_IMAGE_W;
			// set light info
			
			if (nSpriteNum < EXPLRECT_MOVIE_NBLITSPRITES)
			{
				nMaxLit = 255;
				nMinLit = 245 - 90*CalcLinear_Int(nSpriteNum, 0, EXPLRECT_MOVIE_NBLITSPRITES-1);
				nAlphaLevel = 255;
				nRadius = -1;
			}
			else
			{
				nMaxLit = 255 - 96*CalcLinear_Int(nSpriteNum, EXPLRECT_MOVIE_MAXSPRITESANIM/2, EXPLRECT_MOVIE_MAXSPRITESANIM-1);
				nMinLit = 155 - 155*CalcLinear_Int(nSpriteNum, EXPLRECT_MOVIE_NBLITSPRITES-1, EXPLRECT_MOVIE_MAXSPRITESANIM/4);
				nAlphaLevel = 255 - 237*CalcLinear_Int(nSpriteNum-EXPLRECT_MOVIE_MAXSPRITESANIM, -EXPLRECT_MOVIE_NBDARKSPRITES-1, -1);
				nRadius += 2;
			}
			nDiffLit = nMaxLit-nMinLit;
		
			// carve the radius
			
			if (nRadius >= 0)
			{
				char nMinNx = MAX(0, nCenterX-nRadius);
				char nMinNy = MAX(0, nCenterY-nRadius);
				char nMaxNx = MIN(EXPLRECT_IMAGE_W-1, nCenterX+nRadius);
				char nMaxNy = MIN(EXPLRECT_IMAGE_H-1, nCenterY+nRadius);
				
				for (nx = nMinNx; nx <= nMaxNx; nx++)
				{
					for (ny = nMinNy; ny <= nMaxNy; ny++)
					{
						short nAddLit = 
							( abs(nx-nCenterX) + abs(ny-nCenterY) <= nRadius ) ? nAddLitMax : (nAddLitMax/2);
						
						nAddLit = nGrid[nx][ny] - nAddLit;
						nGrid[nx][ny] = MAX(0, nAddLit);
					}
				}
			}
			
			
			// color the result
			
			for (nx=0; nx < EXPLRECT_IMAGE_W; nx++)
			{
				for (ny=0; ny < EXPLRECT_IMAGE_H; ny++)
				{
					unsigned char nVal = nGrid[nx][ny]*nDiffLit/255;
					if (nVal > 0)
					{
						unsigned char nAlpha2 = nAlphaLevel*CalcLinear_Int(nVal+nMinLit, 0, 64);
						
						nVal = nMinLit + ( rand()%256 )*nVal/255;
						al_put_pixel(nx + nMovieXOffset, ny
							, al_map_rgba(nVal,nVal,nVal, nAlpha2)
							);
					}
				}
			}
			
		}
		
		al_unlock_bitmap(bmpTmp);
		
		CMovieClip* pMovieClip = new CMovieClip();
		ASSERT(pMovieClip != NULL);
		pMovieClip->CreateFromBitmap_Multi_ImageWidth(bmpTmp, NULL, EXPLRECT_IMAGE_W,
			NULL, SPRINIT_HASALREADYALPHA, ANIM_FORWARD);
		pMovieClip->InitVars_Fps(-1, 1);
		_pListMovieClips->Add_andAffectExternalId(pMovieClip, MOVIEID_EXPLRECT0 + nMovieNum);
	}

	al_destroy_bitmap(bmpTmp);
	_pListMovieClips->SetSearchIndexes();	
}

/*-------------------------------------------------------------------------*/
/*---------------------- Create Bitmaps Ground Limit ----------------------*/
/*-------------------------------------------------------------------------*/
void CreateBitmaps_GroundLimit()
{
	unsigned char nx, ny, nGrid[GROUND_SHIELD_IMAGE_W][GROUND_SHIELD_IMAGE_H];
	
	ALLEGRO_BITMAP* bmpTmp = al_create_bitmap(GROUND_SHIELD_IMAGE_W*GROUND_SHIELD_MAXSPRITENUM, GROUND_SHIELD_IMAGE_H);
	
	int nRandNum = 573;
	char nSpriteNum;

	for (nx=0; nx < GROUND_SHIELD_IMAGE_W; nx++)
	{
		for (ny=0; ny < GROUND_SHIELD_IMAGE_H; ny++)
		{
			nGrid[nx][ny] = _nForcedRandItems[ nRandNum%FORCED_RAND_ITEMS ];
			nRandNum++;
		}
	}
		
	al_set_target_bitmap(bmpTmp);
	al_clear_to_color(COL_ZEROALPHA);
	al_lock_bitmap(bmpTmp, ALLEGRO_PIXEL_FORMAT_ANY, ALLEGRO_LOCK_WRITEONLY);
	
	for (nSpriteNum = 0; nSpriteNum < GROUND_SHIELD_MAXSPRITENUM; nSpriteNum++)
	{
		unsigned short nMovieXOffset = nSpriteNum*GROUND_SHIELD_IMAGE_W;

		// move light info

		for (nx=0; nx < GROUND_SHIELD_IMAGE_W; nx++)
		{
			for (ny=0; ny < GROUND_SHIELD_IMAGE_H; ny++)
			{
				nGrid[nx][ny]++;
			}
		}
		
		// color the result
		for (ny=0; ny < GROUND_SHIELD_IMAGE_H; ny++)
		{
			unsigned char nAlpha = 127 + 128*ny/GROUND_SHIELD_IMAGE_H;

			for (nx=0; nx < GROUND_SHIELD_IMAGE_W; nx++)
			{
				unsigned char nVal = (nGrid[nx][ny]%GROUND_SHIELD_MAXSPRITENUM)*16;
				al_put_pixel(nx + nMovieXOffset, ny
					, al_map_rgba(nVal,nVal,nVal
						, nAlpha*(127 + nVal)/384)
					);
			}
		}
	}
	
	al_unlock_bitmap(bmpTmp);
	
	CMovieClip* pMovieClip = new CMovieClip();
	ASSERT(pMovieClip != NULL);
	pMovieClip->CreateFromBitmap_Multi_ImageWidth(bmpTmp, NULL, GROUND_SHIELD_IMAGE_W,
		NULL, SPRINIT_HASALREADYALPHA, ANIM_FORWARD);
	pMovieClip->InitVars_Fps(-1, 2);
	_pListMovieClips->Add_andAffectExternalId(pMovieClip, MOVIEID_GROUND_SHIELD0);

	al_destroy_bitmap(bmpTmp);
	_pListMovieClips->SetSearchIndexes();	
}



/*-------------------------------------------------------------------------*/
/*---------------------------- Init other stuff ---------------------------*/
/*-------------------------------------------------------------------------*/
void init_other_stuff()
{
	/*--- init cosmetics objects ------------------------------------------*/

	_nCellLitInfos = (CellInfo_t*)malloc(LITCELLS_MAX_ITEMS*sizeof(CellInfo_t));

	CreateBitmaps_LitCells();
	CreateBitmaps_ExplRects();
	CreateBitmaps_GroundLimit();
	InitLitCells_SpritePos();
}

