/***************************************************************************/
/*                                                                         */
/*                                M A I N                                  */
/*                                                                         */
/***************************************************************************/




#include <vld.h> // VISUAL LEAK DETECTOR
#include <stdio.h>
#include <allegro5/allegro.h>
#include <allegro5/allegro_primitives.h>
#include <allegro5/allegro_opengl.h>
#include "../../MyFrameAl5/globalIncs.h"
#include "../../MyFrameAl5/Prj/Prj.h"
#include "../../MyFrameAl5/File/MyErrorGUI.h"
#include "../../MyFrameAl5/Ctrl/JoypadDevice.h"
#include "../../MyFrameAl5/FrameGlobalVars.h"
#include "../../MyFrameAl5/Game/GameSection.h"
#include "../../MyFrameAl5/Stat/ListStatCommon.h"
#include "../../MyFrameAl5/Draw/mytext.h"
#include "../../MyFrameAl5/Obj/Boundary.h"
#include "../../MyFrameAl5/Draw/MovieClip.h"
#include "../../MyFrameAl5/Draw/TextScroller.h"
#include "../../MyFrameAl5/Math/CalcHelper.h"
#include "../../MyFrameAl5/Font/FontClip.h"
#include "../../MyFrameAl5/Menu/MenuDebugCommon.h"
#include "../../MyFrameAl5/Font/FontMenu.h"
#include "../../MyFrameAl5/Menu/Page.h"
#include "../../MyFrameAl5/Menu/PageDebugFont.h"
#include "../../MyFrameAl5/Game/JoinEngine.h"
#include "../../MyFrameAl5/Math/mycosine.h"
#include "../../MyFrameAl5/Math/MyRand.h"
#include "GlobalDefs.h"
#include "init.h"
#include "MyJoinEngine.h"
#include "layout.h"
#include "MyGameHelper.h"

void init_sprites();

/*-------------------------------------------------------------------------*/
/*---------------------------- Init with loading --------------------------*/
/*-------------------------------------------------------------------------*/
void init_during_loading()
{
	init_sprites();	

	/*--- Init MyGame Objects ---------------------------------------------*/


}

/*-------------------------------------------------------------------------*/
/*------------------------------ Init sprites -----------------------------*/
/*-------------------------------------------------------------------------*/
void init_sprites()
{
	MyDebugInfo_Text(3, "init_sprites");
	ASSERT(_pListGradients != NULL);
	ASSERT(_pListSprites == NULL);
	ASSERT(_pListMovieClips == NULL);
	_pListSprites = new CListMyObject(256, true);	
	ASSERT(_pListSprites != NULL);	
	_pListMovieClips = new CListMovieClip();
	ASSERT(_pListMovieClips != NULL);

	CMovieClip* pMovieClip;
	pMovieClip = new CMovieClip();
	ASSERT(pMovieClip != NULL);
	pMovieClip->CreateFromDefaultNbimagesNameIdColor(32, 32, 4, "Temp", -1, COL_BLUE);
	pMovieClip->InitVars_Fps(-1, 4);
	pMovieClip->InitCollision(32,32);
	_pListMovieClips->Add_andAffectExternalId(pMovieClip, MOVIEID_DEFAULTPRIM);


	// End
	_pListMovieClips->SetSearchIndexes();	

	al_set_window_title(_display, "RSD (Rect Sync Defense) by Anto80 & Lucas Fleurance");
	
}

/*-------------------------------------------------------------------------*/
/*----------------------------- My Draw On Top ----------------------------*/
/*-------------------------------------------------------------------------*/
void MyDrawOnTop()
{
	// nothing to draw On Top
}

/*-------------------------------------------------------------------------*/
/*-------------------------------- Main loop ------------------------------*/
/*-------------------------------------------------------------------------*/
void main_loop()
{	
	while (1)
	{		 		
		ALLEGRO_EVENT ev;
		al_wait_for_event(_event_queue, &ev);	  
 
		bool bNeedExit = false;
		CPrj::ManageActionInLoop(&ev, bNeedExit);

		///////////////////////////////////

		if (bNeedExit)
		{
			break;
		}
		
		CPrj::ManageDrawInLoop(MyDrawOnTop);
	}
}

/*-------------------------------------------------------------------------*/
/*----------------------------- Closing helper ----------------------------*/
/*-------------------------------------------------------------------------*/
void specific_closing_helper()
{		
	/*
	_pConfig->Save();	

	if (_pMenuServiceMode->m_nNbItems > 5)
	{		
		CPageDebugPattern* pPage = (CPageDebugPattern*)_pMenuServiceMode->GetPageByExternalId(PAGE_DEBUG_PATTERN);
		ASSERT(pPage != NULL);
		pPage->BackupTempObject();
	}
	*/

	free_and_nullify(_nCellLitInfos);
		
	
	delete_and_nullify(_pListAsteroids);
	delete_and_nullify(_pListMyPlayerMissiles);
	delete_and_nullify(_pListMyPlayerExplosions);
	delete_and_nullify(_pListCities);

	delete_and_nullify(_pListMovieClips);	
	delete_and_nullify(_pListSprites);	
	
	
	delete_and_nullify(_pConfig);	
	

	// font and error log deleted in Close_Prj	
}

/*-------------------------------------------------------------------------*/
/*---------------------------------- Main ---------------------------------*/
/*-------------------------------------------------------------------------*/
int main(int argc, char* argv[])
{
	if (0 != CPrj::Init(new CMyErrorGUI(), argc, argv, 640, 480))
		return 1;

	CPrj::PrepareSpecificLoading();
	init_during_loading();
	
	CPrj::EndSpecificLoading(my_init_config, 
		init_menu_specific, init_join_engine, init_game_sections,
		init_other_stuff);

	main_loop();

	specific_closing_helper();
	
	CPrj::Close();	

	return 0;
}
// END_OF_MAIN()
