#if !defined(_MYOBJ_H__GGJ2017MICO__2017_1_20__21_22_30__INCLUDED_)
    #define _MYOBJ_H__GGJ2017MICO__2017_1_20__21_22_30__INCLUDED_


#include "MyLivingObject.h"

#define FORCED_RAND_ITEMS			256

extern unsigned char _nForcedRandItems[ FORCED_RAND_ITEMS ];

class CAsteroid; //predeclaration class

class CAsteroid : public CMyLivingObject
{
public: 



public: 
    CAsteroid(); 
    virtual ~CAsteroid();

public:
	virtual bool IsDisposable();

	void Init();
	virtual int Move();
	virtual int Draw();

	static void Draw_Asteroid_Ex(float fx, float fy, float fForceAlpha);

};


////////////////////////////////////////////////////////////////////

class CMissilePlayer : public CMyLivingObject
{
public: 
	unsigned short m_nTargetCurrentTime;
	unsigned short m_nTargetMaxTime;

	signed short m_nOriginalSourceX;
	signed short m_nOriginalSourceY;
	signed short m_nOriginalDiffX;
	signed short m_nOriginalDiffY;

	unsigned char m_nMissileNumber;

public: 
    CMissilePlayer(); 
    virtual ~CMissilePlayer();

public:
	virtual bool IsDisposable();

	void Init();
	virtual int Move();
	virtual int Draw();

};


////////////////////////////////////////////////////////////////////

class CMyExplosion : public CMyLivingObject
{
public: 
	unsigned short m_nAnimCurrentTime;
	unsigned short m_nAnimMaxTime;
	unsigned char m_nExplosionLevel;
	unsigned char m_nSpawnDelay;

public: 
    CMyExplosion(); 
    virtual ~CMyExplosion();

public:
	virtual bool IsDisposable();

	void Init(int nOriginalX, int nOriginalY, int nExplosionLevel, int nDelay, bool bSound);
	virtual int Collide(CLivingObject *pOtherAsteroid);
	virtual int Move();
	virtual int Draw();

};


////////////////////////////////////////////////////////////////////

class CCityRect : public CMyLivingObject
{
public: 
	short m_nCollapseAnimTime;
	unsigned char m_nCollapseDelay;
	float m_fLayerFactor;
	unsigned char m_nLightPattern;

public: 
    CCityRect(); 
    virtual ~CCityRect();

public:
	virtual bool IsDisposable();
	bool IsCollapsing();

	void Init(short nOriginX);
	void DoAsteroidImpact(CMyLivingObject* pAsteroid);
	virtual int Move();
	virtual int Draw();

};

#endif /* _MYOBJ_H__GGJ2017MICO__2017_1_20__21_22_30__INCLUDED_ */
